/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * create_cfg.c
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <getopt.h>

extern char *program_name;
extern int cfg[];
extern char *env;
extern char *cfgpath;
extern char *cfgfname;
extern pathstruct *p;
extern char *path;
extern int path_no;
extern int pct;
extern struct option long_options[];

int create_cfg(void);


int create_cfg(void)
{
    int i = 0;
    int ret = 0;

    /* Open .cfg file */
    FILE *fh = NULL;

    fh = fopen(cfgpath, "wb");
    if (fh == NULL)
    {
        print(MSG_111, cfgfname);
        print(MSG_112);
        exit (EXIT_FAILURE);
    }

    print("[options]\n");
    ret = fprintf(fh, "[options]\n");

    for (i = 0; i <= FLAGS; i++)
    {
        if (i == PCT)
        {
            print("%s = %d\n", long_options[i].name, cfg[i]);
            ret = fprintf(fh,"%s = %d\n", long_options[i].name, cfg[i]);
        }
        else if (cfg[i] == FALSE)
        {
            print("%s = false\n", long_options[i].name);
            ret = fprintf(fh,"%s = false\n", long_options[i].name);
        }
        else if (cfg[i] == TRUE)
        {
            print("%s = true\n", long_options[i].name);
            ret = fprintf(fh,"%s = true\n", long_options[i].name);
        }
        if (ret <= 0)
            print(MSG_113, MSG_114);
    }

    print("\n[Search Path]\n");
    fprintf(fh, "\n[Search Path]\n");

    for(i = 0; i < path_no; i++)
    {
        print("Search Path [%d] = %s\n", i, p[i].path);
        ret = fprintf(fh, "Search Path [%d] = %s\n", i, p[i].path);
        if (ret <= 0)
            print(MSG_113, MSG_114);
    }

    print("\n");

    ret = fprintf(fh, "\n");
    if (ret <= 0)
        print(MSG_113, MSG_114);

    /* Close MXcleaner.cfg */
    ret = fclose(fh);
    if (ret != 0)
    {
        print(MSG_115, cfgfname);
        exit (EXIT_FAILURE);
    }

    cfgpath = NULL;
    return (ret);
}

