/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * delete_files.c
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "MXcleaner.h"
#include "disp.h"

extern int rec_no;
extern dirstruct *a;
extern pathstruct *p;
extern char *dbl;
extern char *mxd;
extern char *ndb;
extern char *path;
extern int cfg[];

int delete_files(int);
int yes_no(void);


int delete_files(int dp)
{
    int ret = 0;
    int i = 0;
    int _del = 0;
    int fail = 0;
    char *pfx = NULL;

    if (cfg[DEL] == FALSE)
    {
        return 0;
    }

    switch(dp)
    {
    case DBL:
        pfx = dbl;
        break;
    case MXD:
        pfx = mxd;
        break;
    case NDB:
        pfx = ndb;
        break;
    default:
        print(MSG_411, pfx);
        _del = -1;
        return _del;
    }

    print(MSG_412, rec_no);
    print(MSG_413, pfx);

    ret = yes_no();
    print("\n");

    if (ret == FALSE)
    {
        print(MSG_414);
        return -1;
    }

    for (i = 0; i < rec_no; i++)
    {
        if (a[i].flag == dp)
        {
            switch (dp)
            {
            case DBL:
                if (a[i].flag == DBL)
                {
                    sprintf(path, "%s%s%s",
                            p[a[i].path_no].path, dbl, a[i].fname);
                }
                break;
            case MXD:
                if (a[i].flag == MXD)
                {
                    sprintf(path,"%s%s%s",
                            p[a[i].path_no].path, mxd, a[i].fname);
                }
                break;
            case NDB:
                if (a[i].flag == NDB)
                {
                    sprintf(path,"%s%s%s",
                            p[a[i].path_no].path, ndb, a[i].fname);
                }
                break;
            default:
                break;
            }

            switch (dp)
            {
            case DBL:
            case MXD:
            case NDB:
            {
                ret = 0;
                if(cfg[TEST] == FALSE)
                {
                    ret = remove(path);
                }
                if(ret == 0)
                {
                    print(MSG_415, path);
                    _del++;
                }
                else
                {
                    print(MSG_416, path);
                    fail--;
                }
            }
            break;
            default:
                break;
            }
        }
    }

    print(MSG_417, _del, fail);

    return _del;
}

