/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * disp.h (MxCleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DISP
#define _DISP

/* main.c 0xx*/
#define MSG_001 "init() failed\n"
#define MSG_002 "acc: argc: %d %s\n"
#define MSG_003 "get_cmd_line(argc, argv) failed\n"
#define MSG_004 "Failed to remove %s file\n"
#define MSG_005 "Failed to update %s file\n"
#define MSG_006 "Failed to save %s file\n"
#define MSG_007 "read_cfg() failed\n"
#define MSG_008 "Main Search Path [%d] = %s\n"
#define MSG_009 "\n Program name: %s\
                \n Version:      %s\
                \n Author:       %s\
                \n Copyright:    Elmar Haag\
                \n               www.linux.c5ace.com\n\
                \n FREEWARE! NOT FOR SALE!\
                \n You may use, copy and give away this program to anyone.\
                \n You are prohibited from chargeing money for the program\
                \n disks, downloading or installation.\n\
                \n %s is distributed in the hope that it\
                \n will be useful, but WITHOUT ANY WARRANTY; without even\
                \n the implied warranty of MERCHANTABILITY or FITNESS FOR\
                \n A PARTICULAR PURPOSE.\n\
                \n For customised commercial versions contact:\
                \n linux@c5ace.com\n\
                \nTo cancel press Ctrl + C keys\n\n\n"
#define MSG_010 "Failed to read directories and populate database\n"
#define MSG_011 "Failed to remove prefixes from files\n"
#define MSG_012 "\n\nAllocating dynamic data memory: %lu Bytes\n\n\n"

/*
#define MSG_013 "strip_files(argc, argv)\n"
#define MSG_014 "creat_cfg()\n"
*/

/* init 1xx*/
/* strip_files 1xx */
/* fill_p 1xx */


/* get_cmd_line, create_cfg, read_cfg  1xx*/
#define MSG_0101 "Option -p --percent error\n"
#define MSG_0102 "Option -p --percent %s out of valid range"
#define MSG_0103 "\nUse only one of these option:\
\n-i --ignore = Run and keep existing configuration.\
\n-k --kill   = Delete existing configuration.\
\n-u --update = Run and update existing configuration.\
\n-s --save   = Save configuration, do not run.\n"
#define MSG_104 "Search Path [%d] = %s\n"

/*
#define MSG_11  "Search path:\n"
#define MSG_12  "p[%3d].path: %s\n"
#define MSG_13  "Can not close %s file.\n"
*/

/* create_cfg.c */
#define MSG_111 "Can not create %s file.\n"
#define MSG_112 "Try again with \"Root\" or \"Administrator\" priveleges\n"
#define MSG_113 "Can not write to %s file.\n"
#define MSG_114 "Check available disk space and try again\n"
#define MSG_115 "Can not close %s file.\n"

/* read_cfg() 1xx*/
#define MSG_121 "Can not open %s file for reading.\n"
#define MSG_122 "Can not read from %s file.\n"
#define MSG_123 "Option[%d]: -%c --%s\n"
#define MSG_124 "Can not close %s file.\n"

/* show options() 1xx */
#define MSG_131 "Options:\n"
#define MSG_132 "option [%d]: %s\n"
// #define MSG_133 "Options found: %d\n\n\n"

/* read_dirs() 1xx*/
#define MSG_141 "Path List:\n"
#define MSG_142 "Path[%3d]: %s\n"
#define MSG_143 "Path searched: %6d\nFiles found:   %6d\n\n"
#define MSG_144 "read_dir() Line 59 FATAL ERROR: Buffer Overflow, To many Files"
#define MSG_145 "\nFile list:\n"
#define MSG_146 "File #,  Filelength, Flag, Path\n"
#define MSG_147 "Files: %6d \n\n\nMax File Length: %12llu Bytes\n\n\n"
#define MSG_148 "FATAL ERROR! No valid files found"


/* remove_prefix() 2xx*/
#define MSG_201 "Scan %d filenames and remove %s, %s, %s and %s prefix:\n"
#define MSG_202 "Removed %s from: %s%s \n"
#define MSG_203 "Removed %s from: %s%s%s\n"
#define MSG_204 "WARNING! Could not rename %s\n"
#define MSG_205 "Removed prefix: %6d\n"
#define MSG_206 "Remove failed:  %6d\n\n"

/* get_mx_flen() 2xx */
#define MSG_211 "Extracting filelength from %s files\n"
#define MSG_212 " File #,  Filelength, Flag, MX #, Path\n"
#define MSG_213 " File #,  Filelength, Flag, Path\n"
#define MSG_214 "Extracted filelength from %d %s files\n\n"

/* get_nil_flen() 2xx */
#define MSG_221 "Marking NIL filelength files\n"
#define MSG_222 " File #,  Filelength, Flag, NIL#, Path\n"
#define MSG_223 " File #,  Filelength, Flag, Path\n"
#define MSG_224 "Marked %d Zerolength files from %d files\n\n"

/* sort() 30x*/
#define MSG_301 "Sorting: %d Files\n"
#define MSG_302 "Sorted file list:\n"
#define MSG_303 "File #, MX  #, Filelength, Flag, Path\n"
#define MSG_304 "Sorted:  %d Files\n\n"

/* get_mx_data() 31x */
#define MSG_311 "Extracting MX Hash Values from %d %s files\n"
#define MSG_312 "File #,  MX #, Filelength, Flag, Path\n"
#define MSG_313 "MX_hash: "
#define MSG_314 "Extracted  MX Hash Values from %d %s files\n\n\n"

/* mark_files() 32x */
#define MSG_321 "Verify and prefix %d files with \n%s, %s, %s or %s\n"
#define MSG_322 "File #,  MX #, Filelength, Flag, Path\n"
#define MSG_323 "Generated %6d CRC Values and set CRC flag\n"
#define MSG_324 "Generated %6d MX Hash Values and set MXD flag\n"
#define MSG_325 "Verified and marked %d files with\n %s, %s, %s or %s prefix\n\n"

/* print_marked-Files () 33x*/
#define MSG_331 "Hash: %4X %4X\n"
#define MSG_332 "MX_hash:"

/* rename_files() 34x */
#define MSG_341 "Adding %s, %s or %s prefix to marked files\n"
#define MSG_342 "\nrename_files() Line 125: Error %s: rename():  %s\n"
#define MSG_343 "oldpath: %s\nnewpath: %s\n\n"
#define MSG_344 "Added: %s to: %s%s \n"
#define MSG_345 "Added %s to: %s%s%s\n"
#define MSG_346 "Added  %s, %s or %s prefix to %d marked files\n\n"

/* make_hash() 35x */
#define MSG_351 "ERROR: makehash() line 77: %d %s\n"
#define MSG_352 "make_hash() Line 96: Error %s: fh open():  %s\n%s\n"

/* make_mx_hash() 36x */
#define MSG_361 "make_mx_hash() line 27: ERROR: fopen() failed\n"
#define MSG_362 "File #, MX  #, Filelength, Flag, Path\n"
#define MSG_363 "make_mx_hash.c line 28 or 29: ERROR: fseek() failed\n"

/* cmp_files() 37x */
#define MSG_371 "ERROR: cmp_file() line 98: %s\n"
#define MSG_372 "cmp_file() Line 112: Error %s: fh open():  %s\n%s\n"
#define MSG_373 "cmp_file() Line 145: Error %s: fh open():  %s\n%s\n"

/* show list() 40x */
#define MSG_401 "show_list() Invalid argument %s\n"
#define MSG_402 "Files with %s prefix:\n"
#define MSG_403 "File #, Rec #,  Filelength, Path\n"
#define MSG_404 "%d files\n\n\n"

/* delete_files() 41x */
#define MSG_411 "delete_files() Invalid argument %s\n"
#define MSG_412 "Scanning %d files\n"
#define MSG_413 "Files with %s prefix will be permanently deleted and can not be recovered\n"
#define MSG_414 "No files deleted.\n"
#define MSG_415 "Deleted: %s\n"
#define MSG_416 "WARNING! Could not delete %s\n"
#define MSG_417 "\nFiles deleted: %5d\nFiles not deleted: %5d\n\n"

/* strcat_s 90x*/
#define MSG_901 "FATAL ERROR:\
                \nstrcat_s() buffer overflow\
                \nString to large:\
                \nsout: %u\
                \nsin: %u\
                \nTotal: %u\
                \nBuffer size: %u\
                \nsout: %s\
                \nsin: %s\n\n"

/* strcpy_s 90x */
#define MSG_902 "FATAL ERROR:\
                \nstrcpy_s() buffer overflow\
                \nString to large:\
                \nsin: %u Bytes\
                \nBuffer size: %u Bytes\
                \nString: %s\n\n"

/* xmalloc 90x */
/* xrealloc 90x*/
#define MSG_903 "tree: virtual memory exhausted.\n"

/* yes_no 91x */
#define MSG_911 "\nEnter 'Yes' or 'No': "
#define MSG_912 "No"
#define MSG_913 "Yes"

/* elapsed_time 92x*/
#define MSG_921 "Elapsed time:\
                \n %03ld days\
                \n  %02ld hours\
                \n  %02ld minutes\
                \n  %02ld seconds\
                \n %03ld milli seconds\
                \n %03ld micro seconds\n\n"

/* usage 99x*/
#define MSG_991 "Try `%s --help' for more information.\n\n"

#endif
