/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * elapsed_time.c
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <time.h>
#include <sys/time.h>

struct elapsed_t
{
    long int day;
    long int hr;
    long int min;
    long int sec;
    long int msec;
    long int usec;
};

extern int cfg[];

void elapsed_time(int);


void elapsed_time(int what)
{
    ldiv_t t;

    static struct elapsed_t times;
    static struct timeval start, end;

    if (what == START)
        gettimeofday(&start, NULL);

    if (what == STOP)
    {
        gettimeofday(&end, NULL);
        times.sec  = end.tv_sec  - start.tv_sec;

        if (end.tv_usec < start.tv_usec)
        {
            times.sec --;
            times.usec = 1000000 + end.tv_usec - start.tv_usec;
        }
        else
            times.usec = end.tv_usec - start.tv_usec;

        t = ldiv(times.usec, 1000);
        times.usec = t.rem;
        times.msec = t.quot;
        times.sec = times.sec;
        t = ldiv(times.sec, 60);
        times.sec = t.rem;
        t = ldiv(t.quot, 60);
        times.min = t.rem;
        t = ldiv(t.quot, 24);
        times.hr = t.rem;
        times.day = t.quot;

        print(MSG_921,
              times.day, times.hr, times.min, times.sec,
              times.msec, times.usec);
    }
}

