/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * fill_p.c
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <unistd.h>

extern pathstruct *p_cfg;
// extern char *path;
extern int p_cfg_no;
extern int rec_no;

int fill_p(char *);
void get_dirs(void);
void usage(int);


int fill_p(char *spath)
{
    int i = 0;
    int ret = 0;
    int slen = 0;
    int cmp = FALSE;

    for (i = strlen(spath); i > 0 ; i--)
    {
        if (spath[i] == SLASH)
        {
            break;
        }
    }

    if (i == 0)
    {
        pt = getcwd(spath, _FULL_PATH);
    }

    while (spath[i] != '\0')
    {
        switch(spath[i])
        {
        case '/':
        case '\\':
        {
            spath[i] = SLASH;
            break;
        }
        default:
            break;
        }
        i++;
    }

    ret = chdir(spath);
    if (ret == 0)
    {
        pt = getcwd(spath, _MAX_PATH);
        slen = 0;
        slen = strlen(spath);
        if ( ( slen <= (_MAX_PATH - 2))
                && (spath[slen - 1] != SLASH) )
        {
            spath[slen] = SLASH;
            spath[slen + 1] = '\0';
        }

        for (i = 0; i <= p_cfg_no; i++)
        {

            if (strcmp(spath, p_cfg[i].path) == 0)
            {
                cmp = TRUE;
            }
        }

        if (cmp == FALSE)
        {
            strcpy_s(p_cfg[p_cfg_no].path, _MAX_PATH, spath);
            p_cfg[p_cfg_no].path_no = p_cfg_no;
            p_cfg[p_cfg_no].plen = strlen(p_cfg[p_cfg_no].path);
            p_cfg_no++;
            p_cfg = (pathstruct *) xrealloc(p_cfg, sizeof(pathstruct) * (p_cfg_no + 1));
            cmp = FALSE;
        }
    }
    return ret;
}

