/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * get_mx_flen.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <ctype.h>

extern char ext[3][5];
extern int mx_rec_no;
extern int mx_flag;
extern char *inc;
extern char *mxd;
extern dirstruct *a;
extern pathstruct *p;
extern int cfg[];

int get_mx_flen(int);


int get_mx_flen(int rec_no)
{
    int ret = 0;
    int i = 0;
    int t = 0;
    int idx = 0;
    int slen = 0;
    int s_start = 0;
    int s_end = 0;
    char mx_tmp[16];
    int slen_inc = 0;
    int extlen = 0;
    char *extstr = NULL;
    char *fname = NULL;

    mx_rec_no = 0;
    slen_inc = strlen(inc);
    print(MSG_211, inc);
    if (cfg[VERB] == TRUE)
    {
        if (mx_flag == TRUE)
            print(MSG_212);
        else
            print(MSG_213);
    }

    for (i = 0; i < rec_no; i++)
    {
        ret = 0;
        if ( (strncmp(a[i].fname, inc, slen_inc) == 0) ||
                (strncmp(a[i].fname, mxd, strlen(mxd)) == 0))
        {
            slen = strlen(a[i].fname);
            extstr = strrchr (a[i].fname, '.');
            extlen = strlen(extstr);
            strcpy_s(mx_tmp, 16, extstr);
            idx = 0;
            while (mx_tmp[idx] != '\0')
            {
                mx_tmp[idx] = toupper(mx_tmp[idx]);
                idx++;
            }
            idx = 0;
            while(idx <= 1)
            {
                ret = strcmp(mx_tmp, ext[idx]);
                if (ret == 0)
                    break;
                idx++;
            }
            idx = 0;
            if (ret == 0) /* AUDIO */
            {
                s_end = slen - extlen;
                s_end = s_end - (PLAY_TIME + FREQ + BITRATE) *2;
            }
            else /* VIDEO */
            {
                s_end = slen - extlen;
            }
            /* Parse filelenth */
            s_start = s_end - FIL_LEN * 2;
            for( t = s_start; t < s_end; t++)
            {
                mx_tmp[idx] = a[i].fname[t];
                idx++;
            }
            mx_tmp[idx] = '\0';
            idx = 0;
            a[i].flen = (long long int) strtoul(mx_tmp, NULL, 16);
            a[i].flag = INC;
            a[i].mx_rec_no = mx_rec_no;
            mx_flag = TRUE;

            if (cfg[VERB] == TRUE)
            {
                if (strncmp(a[i].fname, mxd, strlen(mxd)) == 0)
                    fname = &a[i].fname[strlen(mxd)];
                else
                    fname = &a[i].fname[0];

                if(mx_flag == TRUE)
                {
                    print(" %6d %12lld   %s%6d %s%s\n",
                          a[i].rec_no,
                          a[i].flen,
                          fl[a[i].flag],
                          a[i].mx_rec_no,
                          p[a[i].path_no].path,
                          fname);
                }
                else
                {
                    print(" %6d %12lld   %s/%s%s\n\n",
                          a[i].rec_no,
                          a[i].flen,
                          fl[a[i].flag],
                          p[a[i].path_no].path,
                          fname);
                }
            }
            mx_rec_no++;
        }
    }

    print(MSG_214, mx_rec_no, inc);

    return (mx_rec_no);
}

