/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * gert _rec_no.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#define __USE_FILE_OFFSET64
#define __USE_LARGEFILE64
#define __USE_GNU
#define _XOPEN_SOURCE 500

#include "MXcleaner.h"
#include <ftw.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>

#ifndef USE_FDS
#define USE_FDS 20
#endif

dirstruct *a;
pathstruct *p;
extern pathstruct *p_cfg;
// extern int cfg[];
// extern int path_no;
extern int rec_no;


int get_rec_no(int);
int inc_rec_no(const char *, const struct stat *,
               const int, struct FTW *);


int get_rec_no(int p_cfg_no)
{
    int i = 0;
    int p_no = p_cfg_no;
    int flags =  FTW_F;

    rec_no = 0;
    for (i = 0; i < p_no; i++)
    {
        if (nftw(p_cfg[i].path, inc_rec_no, USE_FDS, flags) == -1)
        {
            perror("nftw");
            exit(EXIT_FAILURE);
        }
    }

    a = (dirstruct *) xcalloc(sizeof(dirstruct) * (rec_no + 1));

    return(EXIT_SUCCESS);
}

#pragma GCC diagnostic ignored "-Wunused-parameter"
int inc_rec_no(const char *filepath, const struct stat *info,
               const int typeflag, struct FTW *pathinfo)
{
#pragma GCC diagnostic warning "-Wunused-parameter"
    if (typeflag == FTW_F)
    {
        /*
        printf("path#  rec# %2d %-2s %2d %5jd %-75s %d %s\n",
                   path_no,
                   rec_no,
                   (typeflag == FTW_D) ?   "d"   : (typeflag == FTW_DNR) ? "dnr" :
                   (typeflag == FTW_DP) ?  "dp"  : (typeflag == FTW_F) ?   "f" :
                   (typeflag == FTW_NS) ?  "ns"  : (typeflag == FTW_SL) ?  "sl" :
                   (typeflag == FTW_SLN) ? "sln" : "???",
                   pathinfo->level,
                   (intmax_t) info->st_size,
                   filepath,
                   pathinfo->base,
                   filepath + pathinfo->base);
        */
//        printf("path_no: %3d rec_no: %6d\n\n", path_no, rec_no);
        rec_no++;
    }

    return 0;           /* To tell nftw() to continue */
}



