/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * init.c
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <locale.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

uid_t usr;

/* Globals */
pathstruct *p_cfg = NULL;
dirstruct *a = NULL;
dirstruct *b = NULL;

int exit_status;
int rec_no;
int path_no;
int p_cfg_no;
int mx_rec_no;
int nil_rec_no;
int opt_no;
int mx_flag;
int nil_flag;
int pct;

char ap[_FULL_PATH];
char bp[_FULL_PATH];
char *p = NULL;
char *pt = NULL;
char *tmp = NULL;
char *path = NULL;
char *program_name;
unsigned char cfg[CFLAGS];

char *dbl = "__DUPLICATE__";
char *dif = "__DIFF_DUPLICATE__";
char *mxd = "__MX_DUPLICATE__";
char *inc = "__INCOMPLETE___";
char *ndb = "__ZERO_LENGTH__";

char ext[3][5] =
{
    {".MP3"},
    {".OGG"},
    {0}
};

char fl[9][4] =
{
    {"NON"},
    {"INC"},
    {"MXD"},
    {"DBL"},
    {"DIF"},
    {"NDB"},
    {"NIL"},
    {"CRC"},
    {"ERR"},
};

char *cfgfname = "MXconfig.cfg";
char *cfgdir = ".etc";
char *cfgpath;
char *cwdname = ".";
char *parent = "..";

/* Funcltion declartions */
int init(void);


int init(void)
{
    int ret = 0;

    p_cfg = (pathstruct *) xcalloc (sizeof(pathstruct));
    path = (char *) xcalloc(_FULL_PATH);
    tmp = (char*) xcalloc(_FULL_PATH);
    cfgpath = (char *) xcalloc(_FULL_PATH);

    /* INITIALISE */
    usr = getuid();
    pct = 0;
    path_no = 0;
    p_cfg_no = 0;
    memset(cfg, FALSE, CFLAGS);

    /* create ~/.etc dir */
    cfgpath[0] = '\0';
    sprintf(path, "%s%c%s", getenv(STR_HOME), SLASH, cfgdir);

    ret = access(path, R_OK | W_OK | F_OK); //chdir(path);
    if (ret != 0)
    {
        ret = 0;
        ret = mkdir(path, S_IRWXU);
    }
/*
    if (ret == 0)
    {
        ret = chdir(tmp);
    }
*/
    snprintf(cfgpath, _FULL_PATH, "%s%c%s", path, SLASH, cfgfname);
    program_name = PROGRAM_NAME;
    setlocale (LC_ALL, "");
    rec_no = 0;
    mx_rec_no = 0;
    nil_rec_no = 0;
    opt_no = 1;
    mx_flag = FALSE;
    nil_flag = FALSE;

    return ret;
}

