/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * make_hash.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>

extern char *path;
extern dirstruct *a;
extern pathstruct *p;
extern char *program_name;

// int lstat64 (const char*, struct stat64*);
void make_hash(int);
long long int filesize (char *);


void make_hash(int i)
{
    int fh = 0;
    unsigned long long int idx = 0;
    long long int ret = 0;
    unsigned long long int crc = 0;
    unsigned long long int buf[BUF_SIZE];
    ull_div_t y;
    int bs = BUF_SIZE;
    int us = ULLI_SIZE;

    memset(buf, 0x00, sizeof(unsigned long long) * BUF_SIZE);
    memset(path, 0x00, _FULL_PATH);
    snprintf(path, _FULL_PATH -1, "%s%s",
             p[a[i].path_no].path, a[i].fname);
    y = ulldiv(bs, us);

    fh = open(path, O_RDONLY, 0);
    if ( fh == -1)
    {
        fprintf (stderr, MSG_352, program_name, strerror (errno), path);
    }

    while (ret < a[i].flen)
    {
        if ((a[i].flen - ret) < bs)
            memset(buf, 0x00, bs);
        ret = ret + read(fh, buf, bs);
        for (idx = 0; idx < y.quot; idx++)
        {
            crc = crc ^ buf[idx];
        }
    }

    close(fh);

    a[i].hash = crc;
    a[i].flag = CRC;
}
