/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mark_files.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"

typedef union
{
    unsigned int ui_h[2];
    unsigned long long int ulli_h;
} uh;

/* extern int rec_no; */
extern dirstruct *a;
extern pathstruct *p;
extern int cfg[];
extern char *dbl;
extern char *dif;
extern char *mxd;
extern char *ndb;
extern int rec_no;
extern int mx_flag;

void mark_files(void);
int cmp_file(int, int, int);
unsigned long long int make_hash(int);
void make_mx_hash(int);
int cmp_mx_hash(int ar, int br);


void mark_files(void)
{
    int i = 0;
    int idx = 0;
    int ar = 0;
    int br = 1;
    int lo = 0;
    int hi = 0;
    int crc = FALSE;
    int inc = FALSE;
    int zro = FALSE;
    int mkh = 0;
    int mkmxh = 0;

    print(MSG_321, rec_no, dbl, dif, mxd, ndb);
    if (cfg[VERB] == TRUE)
    {
        print(MSG_322);
    }

    ar = 0;
    br = 1;
    for (ar = 0; ar < rec_no; ar++)
    {
        while (a[ar].flen >= a[br].flen)
        {
            if (br < rec_no)
            {
                if (a[ar].flen == a[br].flen)
                {
                    lo = ar;
                    hi = br;
                    if( (a[ar].flag == INC)
                            || (a[br].flag == INC) )
                    {
                        inc = TRUE;
                    }
                    if( (a[ar].flag == NON)
                            || (a[br].flag == NON) )
                    {
                        crc = TRUE;
                    }
                }
//                print_debug("mark_files()", 91, ar);
            }
            br++;
            if (br > rec_no)
                break;
//            print_debug("mark_files()", 96, ar);
//            print_debug("mark_files()", 97, br);
        }

        for (i = lo; i <= hi; i++)
        {
            if ( (a[i].mx_rec_no == -1)
                    && (a[i].flag != NIL) )
            {
                if(inc == TRUE)
                {
                    make_mx_hash(i);
                    mkmxh++;
                }
                if (crc == TRUE)
                {
                    make_hash(i);
                    mkh++;
                }
            }
//           print_debug("mark_files()", 116, i);
        }

        for (i = lo; i <= hi; i++)
        {
            for (idx = i; idx <= hi; idx++)
            {
                if (i != idx)
                {
                    if ( (a[i].flag != INC)
                            && (a[i].flag != NIL) )
                    {
                        if ( (a[i].hash == a[idx].hash)
                                && (a[idx].flag != DBL) )
                        {
                            a[idx].flag = DBL;
                        }
                        else if ( (a[i].flag == CRC)
                                  && (a[idx].flag == CRC))
                        {
                            if ( (a[i].hash != a[idx].hash)
                                    && (a[idx].flag != DIF) )
                            {
                                if (cfg[PCT] == 0)
                                {
                                    a[idx].flag = DIF;
                                }
                                else if (cfg[PCT] > 0)
                                {
                                    a[idx].flag = cmp_file(i, idx, cfg[PCT]);
                                }
                            }
                        }
                    }
                }
//                print_debug("mark_files()", 149, i);
            }
//            print_debug("mark_files()", 151, i);
        }

        if (mx_flag == TRUE)
        {
            for (i = lo; i <= hi; i++)
            {
                for(idx = i; idx <= hi; idx++)
                {
                    if (i != idx)
                    {
                        if (a[i].flag == INC)
                        {
                            if (cmp_mx_hash(i, idx) == TRUE)
                            {
                                if(a[i].flag != MXD)
                                {
                                    a[i].flag = MXD;
                                }
                            }
                        }
                    }
//                   print_debug("mark_files()", 175, i);
                }
//                print_debug("mark_files()", 177, i);
            }
        }

        if (zro == FALSE)
        {
            for (i = lo; i <= hi; i++)
            {
                for(idx = i; idx <= hi; idx++)
                {
                    if (i != idx)
                    {
                        if (a[i].flag == NIL)
                        {
                            if (a[i].flag == a[idx].flag)
                            {
                                a[idx].flag = NDB;
                                zro = TRUE;
                            }
                        }
                    }
//                    print_debug("mark_files()", 196, i);
                }
//                print_debug("mark_files()", 198, i);
            }
        }

        lo = 0;
        hi = 0;
        inc = FALSE;
        crc = FALSE;
        ar = br -1;
        br = br +1;
//        print_debug("mark_files()", 210, ar);
    }

//    print_marked_file(idx);
    print(MSG_323, mkh);
    if (mx_flag == TRUE)
        print(MSG_324, mkmxh);
    print(MSG_325, rec_no, dbl, dif, mxd, ndb);
}

