/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * mark_files.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"

typedef union
{
    unsigned int ui_h[2];
    unsigned long long int ulli_h;
} uh;

extern dirstruct *a;
extern pathstruct *p;
extern int cfg[];
extern char *dbl;
/* extern char *dif; */
extern char *mxd;
extern char *ndb;
extern int rec_no;


void print_marked_file()
{
    int i = 0;
    int t = 0;
    uh h;
    char *fname;

//    if (cfg[VERB] == TRUE)
    {
        for(i = 0; i < rec_no; i++)
        {
            if (strncmp(a[i].fname, dbl, strlen(dbl)) == 0)
                fname = &a[i].fname[strlen(dbl)];
            else if (strncmp(a[i].fname, mxd, strlen(mxd)) == 0)
                fname = &a[i].fname[strlen(mxd)];
            else if (strncmp(a[i].fname, ndb, strlen(ndb)) == 0)
                fname = &a[i].fname[strlen(ndb)];
            else /* if (a[i].flag != NON) */
                fname = &a[i].fname[0];

            print("%6d %6d %12lld  %s  %s%s\n",
                   a[i].rec_no,
                   a[i].mx_rec_no,
                   a[i].flen,
                   fl[a[i].flag],
                   p[a[i].path_no].path,
                   fname);

            if (a[i].hash != 0)
            {
                h.ulli_h = a[i].hash;
               print(MSG_331, h.ui_h[1], h.ui_h[0]);
            }

            if (a[i].flag == MXD)
            {
                print(MSG_332);
                for (t = 0; t < 4; t++)
                {
                   print("%08x ", a[i].mx_hash[t]);
                }
                print("\n\n");
            }
        }
    }
}

