/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * put_rec.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#define __USE_FILE_OFFSET64
#define __USE_LARGEFILE64


#include "MXcleaner.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>


extern dirstruct *a;
extern pathstruct *p;
extern pathstruct *p_cfg;
extern int cfg[];
extern int path_no;
extern int rec_no;
int ctn;

int put_rec(void);

int put_rec(void)
{
    int j = 0;
    DIR *dp = NULL;
    struct dirent *ep;
    struct stat64 info;
    int itmp = 0;
    int ret = 0;

    rec_no = 0;
    for (j = 0; j < path_no; j++)
    {
        ret = chdir(p[j].path);
        dp = opendir (p[j].path);

        if( dp != NULL)
        {
            while( (ep = readdir(dp)) != NULL )
            {
                itmp = (int) ep->d_type;
                if (itmp == 8)
                {
                    ret = lstat64(ep->d_name, &info);
                    a[rec_no].flen = info.st_size;
                    a[rec_no].rec_no = rec_no;
                    a[rec_no].path_no = j;
                    a[rec_no].mx_rec_no = -1;
                    a[rec_no].flag = FALSE;
                    a[rec_no].hash = 0;
                    a[rec_no].mx_hash[0] = 0;
                    strcpy_s(a[rec_no].fname, _MAX_FNAME, ep->d_name);
                    /*
                    print("%6d %6d %12lld   %s  %s%s\n",
                      a[rec_no].path_no,
                      a[rec_no].rec_no,
                      a[rec_no].flen,
                      fl[a[rec_no].flag],
                      p[a[rec_no].path_no].path,
                      a[rec_no].fname);
                    */
                    rec_no++;
                }
            }
            (void) closedir (dp);
        }
    }
    return(ret);
}

