/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * remove_prefix.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"

extern int cfg[];
extern char *dbl;
extern char *dif;
extern char *mxd;
extern char *ndb;
extern char *inc;
extern dirstruct *a;
extern pathstruct *p;
extern int mx_flag;
extern int nil_flag;

int remove_prefix(int);


int remove_prefix(int rec_no)
{
    int ret = 0;
    int i = 0;
    int fail_ctn = 0;
    int ren_ctn = 0;
    int slen_dbl = 0;
    int slen_dif = 0;
    int slen_mxd = 0;
    int slen_ndb = 0;
    char oldpath[_FULL_PATH];
    char newpath[_FULL_PATH];
    char *flag = NULL;

    slen_dbl = strlen(dbl);
    slen_dif = strlen(dif);
    slen_mxd = strlen(mxd);
    slen_ndb = strlen(ndb);


    print(MSG_201, rec_no, dbl, dif, mxd, ndb);

    for (i = 0; i < rec_no; i++)
    {
            ret = 0;
        if ( (mx_flag == FALSE)
                && (strncmp(a[i].fname, inc, strlen(inc)) == 0))
            mx_flag = TRUE;
        if ( (nil_flag == FALSE)
                && (a[i].flen == 0) )
            nil_flag = TRUE;

        if (strncmp(a[i].fname, dbl, slen_dbl) == 0)
        {
            sprintf(oldpath, "%s%s",
                    p[a[i].path_no].path, a[i].fname);
            sprintf(newpath,"%s%s",
                    p[a[i].path_no].path, &a[i].fname[slen_dbl]);
            if (cfg[TEST] == FALSE)
                strcpy_s(a[i].fname, _MAX_FNAME, &a[i].fname[slen_dbl]);
            flag = dbl;
            ret = 1;
        }
        else if (strncmp(a[i].fname, dif, slen_dif) == 0)
        {
            sprintf(oldpath, "%s%s",
                    p[a[i].path_no].path, a[i].fname);
            sprintf(newpath, "%s%s",
                    p[a[i].path_no].path, &a[i].fname[slen_dif]);
            if (cfg[TEST] == FALSE)
                strcpy_s(a[i].fname, _MAX_FNAME, &a[i].fname[slen_dif]);
            flag = dif;
            ret = 1;
        }
        else if (strncmp(a[i].fname, mxd, slen_mxd) == 0)
        {
            sprintf(oldpath, "%s%s",
                    p[a[i].path_no].path, a[i].fname);
            sprintf(newpath, "%s%s",
                    p[a[i].path_no].path, &a[i].fname[slen_mxd]);
            if (cfg[TEST] == FALSE)
                strcpy_s(a[i].fname, _MAX_FNAME, &a[i].fname[slen_mxd]);
            flag = mxd;
            ret = 1;
        }
        else if (strncmp(a[i].fname, ndb, slen_ndb) == 0)
        {
            sprintf(oldpath, "%s%s",
                    p[a[i].path_no].path, a[i].fname);
            sprintf(newpath, "%s%s",
                    p[a[i].path_no].path, &a[i].fname[slen_ndb]);
            if (cfg[TEST] == FALSE)
                strcpy_s(a[i].fname, _MAX_FNAME, &a[i].fname[slen_ndb]);
            flag = ndb;
            ret = 1;
        }

        if (ret == 1)
        {
            ret = 0;
            if (cfg[TEST] == FALSE)
            {
                ret = rename(oldpath, newpath);
                a[i].flag = NON;
            }
            if (ret == 0)
            {
                ren_ctn++;
                if (cfg[VERB] == TRUE)
                {
                    if (strncmp(a[i].fname, flag, strlen(flag)) == 0)
                        print(MSG_202,
                              flag, p[a[i].path_no].path, a[i].fname);
                    else
                        print(MSG_203,
                              flag, p[a[i].path_no].path, flag, a[i].fname);
                }
                flag = NULL;
            }
        }

        if(ret != 0)
        {
            print(MSG_204, oldpath);
            fail_ctn++;
        }
    }

    print(MSG_205, ren_ctn);
    print(MSG_206, fail_ctn);
    ret = (int) fail_ctn;

    return (ret);
}
