/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * remove_utf8.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */



#include "MXcleaner.h"
#include "disp.h"

extern dirstruct *a;
extern pathstruct *p;

extern int cfg[];

int remove_utf8(int);

int remove_utf8(int rec_no)
{
    int i = 0;
    int j = 0;
    int k = 0;
    int ret = 0;
    int z = 0;
    int utf8 = FALSE;
    int ren_ctn = 0;
    int fail_ctn = 0;
    char tmpfile[_MAX_FNAME];
    char oldpath[_FULL_PATH];
    char newpath[_FULL_PATH];

    print(MSG_145);
    print(MSG_146);
    for(i = 0; i < rec_no; i++)
    {
        if (i == 3388)
            j = 0;
        j = 0;
        k = 0;
        while(a[i].fname[j] != '\0')
        {
            z = isprint(a[i].fname[j]);
            if (z != 0)
            {
                tmpfile[k] = a[i].fname[j];
                tmpfile[k + 1] = '\0';
                k++;
            }
            else
            {
                utf8 = TRUE;
            }
            j++;
        }

        if (utf8 == TRUE)
        {
//            print("%6d %3d %s\n", i, strlen(a[i].fname), a[i].fname);
//            print("%6d %3d %s\n\n", i, strlen(tmpfile), tmpfile);
            if (cfg[TEST] == FALSE)
            {
                sprintf(oldpath, "%s%s",
                        p[a[i].path_no].path, a[i].fname);
                sprintf(newpath, "%s%s",
                        p[a[i].path_no].path, tmpfile);
                ret = rename(oldpath, newpath);
                strcpy_s(a[i].fname, _MAX_FNAME, tmpfile);
                if (ret == 0)
                {
                    ren_ctn++;
                }
                if (ret != 0)
                {
                    fail_ctn++;
                    print(MSG_204, a[i].fname);
                }
            }
            print("%6d %3d %s\n\n", i, strlen(a[i].fname), a[i].fname);
            utf8 = FALSE;
        }
    }
    print(MSG_205, ren_ctn);
    print(MSG_206, fail_ctn);
    return rec_no;
}
