/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * rename_files.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"
#include <fcntl.h>
#include <unistd.h>


extern int rec_no;
extern char *program_name;
extern dirstruct *a;
extern pathstruct *p;
extern char *dbl;
extern char *dif;
extern char *mxd;
extern char *ndb;
extern int cfg[];

void rename_files(void);


void rename_files(void)
{
    int ret = FALSE;
    int i = 0;
    int fh = 0;
    int ctn = 0;
    char *flag = NULL;
    char oldpath[_FULL_PATH];
    char newpath[_FULL_PATH];

    print(MSG_341, mxd, dbl, ndb);

    for (i = 0; i <rec_no; i++)
    {
        ret = TRUE;
        flag = NULL;
        oldpath[0] = '\0';
        newpath[0] = '\0';
        sprintf(oldpath,"%s%s",
                p[a[i].path_no].path, a[i].fname);

        switch (a[i].flag)
        {
        case DBL:
        {
            if (cfg[TEST] == TRUE)
                strcpy_s(newpath, _MAX_PATH, oldpath);
            else
                sprintf(newpath, "%s%s%s",
                        p[a[i].path_no].path, dbl, a[i].fname);
            flag = dbl;
            break;
        }
        case DIF:
        {
            if (cfg[TEST] == TRUE)
                strcpy_s(newpath, _MAX_PATH, oldpath);
            else
                sprintf(newpath, "%s%s%s",
                        p[a[i].path_no].path, dif, a[i].fname);
            flag = dif;
            break;
        }
        case MXD:
        {
            if (cfg[TEST] == TRUE)
                strcpy_s(newpath, _MAX_PATH, oldpath);
            else
                sprintf(newpath, "%s%s%s",
                        p[a[i].path_no].path, mxd, a[i].fname);
            flag = mxd;
            break;
        }
        case NDB:
        {
            if (cfg[TEST] == TRUE)
                strcpy_s(newpath, _MAX_PATH, oldpath);
            else
                sprintf(newpath, "%s%s%s",
                        p[a[i].path_no].path, ndb, a[i].fname);
            flag = ndb;
            break;
        }
        default:
            ret = FALSE;
            break;
        }

        if (ret == TRUE)
        {
            fh = open(oldpath, O_RDONLY);
            if (fh > 0)
                close(fh);
            else
                ret = -1;

            ret = rename(oldpath, newpath);
            if ( ret == -1)
            {
                print(MSG_342, program_name, strerror (errno));
                print(MSG_343, oldpath, newpath);
            }
            else
            {
                ctn++;
                if (cfg[VERB] == TRUE)
                {
                    if (strncmp(a[i].fname, flag, strlen(flag)) == 0)
                        print(MSG_344,
                              flag, p[a[i].path_no].path, a[i].fname);
                    else
                        print(MSG_345,
                              flag, p[a[i].path_no].path, flag, a[i].fname);
                }
            }
        }
    }

    print(MSG_346, mxd, dbl, ndb, ctn);
}
