/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * show_list.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"

extern dirstruct *a;
extern pathstruct *p;
extern char *dbl;
extern char *dif;
extern char *mxd;
extern char *ndb;
extern int rec_no;

int show_list(int);


int show_list(int dp)
{
    int i = 0;
    int f = 0;
    char *s = NULL;

    switch(dp)
    {
    case DBL:
        s = dbl;
        break;
    case DIF:
        s = dif;
        break;
    case MXD:
        s = mxd;
        break;
    case NDB:
        s = ndb;
        break;
    default:
        print(MSG_401, s);
        return -1;
    }

    print(MSG_402, s);
    print(MSG_403);

    for (i = 0; i < rec_no; i++)
    {
        if (a[i].flag == dp)
        {
            if (strncmp(a[i].fname, s, strlen(s)) == 0)
            {
                print("%6d %6d %12lld %s%s\n",
                      f, a[i].rec_no, a[i].flen, p[a[i].path_no].path, a[i].fname);
            }
            else
            {
                print("%6d %6d %12lld %s%s%s\n",
                      f, a[i].rec_no, a[i].flen, p[a[i].path_no].path, s, a[i].fname);
            }
            f++;
        }
    }
    print(MSG_404, f);

    return f;
}

