/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * sort.c (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "MXcleaner.h"
#include "disp.h"

extern int rec_no;
extern int cfg[];
// extern dirstruct *a;
extern dirstruct *b;
//extern pathstruct *p;
//extern char *dbl;
//extern char *dif;
//extern char *mxd;
//extern char *ndb;

void *sort(dirstruct *, int);


/* Sort "a" array */
void *sort(dirstruct *a, int n)
{
    int i = 0;
    long long int bb = 0 , bk = 0, m = 0, exp = 1;

    b = (dirstruct *) xrealloc (b, sizeof(dirstruct) * (n + 1));

    print(MSG_301, rec_no);

    /* Get Max File Size */
    for(i = 0; i < n; i++)
    {
        if(a[i].flen > m)
            m = a[i].flen;
    }

    while((m / exp) > 0)
    {
        long long int bucket[FACTOR] =
        {
            0
        };
        for(i = 0; i < n; i++)
        {
            bk = (a[i].flen / exp % FACTOR);
            bucket[bk]++;
        }

        for(i = 1; i < FACTOR; i++)
        {
            bucket[i] = (bucket[i] + bucket[i - 1]);
        }

        for(i = n - 1; i >= 0; i--)
        {
            bb = (--bucket[a[i].flen / exp % FACTOR]);
            bk = a[i].flen;
            b[bb] = a[i];
        }

        for(i = 0; i < n; i++)
        {
            a[i] = b[i];
            a[i].rec_no = i;
         }

        exp *= FACTOR;
    }
    free(b);
    b = NULL;

    if (cfg[VERB] == TRUE)
    {
        print(MSG_302);
        print(MSG_303);
//        print_marked_file();
    }
    print(MSG_304, rec_no);

    return (a);
}
