/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * use.h (MXcleaner)
 * Copyright (C) Elmar Haag 2018 <linux@c5ace.com>
 *
 * MXcleaner is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * MXcleaner is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

char use[] = "\n"\
"MXcleaner (for Linux or Windows) identifies and marks files with identical \n"\
"contents by prepending __DUPLICATE__ to the filename and identifies \n"\
"__INCOMPLETE___ files of which full versions exist.\n"\
"\n"\
"WinMX __INCOMPLETE___ and matching full version files are identified by \n"\
"compareing the WinMX file hash number. The simple WinMX file hash algorithm\n"\
"occationaly produces the same hash number for different files and therefore\n"\
"is not 100% reliable.\n"\
"\n"\
"Usage:\n"\
"MXcleaner (for Linux) [OPTIONS] [/.../DIRECTORY] [/.../DIRECTORY] ...\n"\
"\n"\
"MXcleaner (for Windows) [OPTIONS] [DRIVE:\\...\\DIRECTORY] \n"\
"                                  [DRIVE:\\...\\DIRECTORY] ...\n"\
"\n"\
"Valid Options:\n"\
"-c --clean      Removes __DUPLICATE__ prefix from duplicate files.\n"\
"                Only usefull if you not use option -d.\n"\
"-d --delete     Deletes duplicate files. Requires you to enter: Yes\n"\
"                to confirm deletion, unless also option -q --quiet is enabled.\n"\
"-i --ignore     Run and keep existing configuration.\n"\
"-k --kill       Delete existing configuration.\n"\
"-q --quiet      Disables all status messages.\n"\
"-p --percent    Sets the percentage files must be identical before they are \n"\
"                marked as duplicate files\n"\
"                Usage -p10 or --percentage10\n"\
"                Default is 0.\n"\
"-r --remove     Removes remaining __DUPLICATE__ and other prefixes from files\n"\
"                not deleted with the -d or --delete option. \n"\
"-s --save       Save configuration.\n"\
"-t --test       Test run. No __DUPLICATE__ is added. No files are deleted.\n"\
"-u --update     Run and update existing configuration.\n"\
"-v --verbose    Show diagnostic information.\n"\
"\n"\
"EXAMPLES:\n"\
"'MXcleaner'\n"\
"Uses the previously saved configuration.\n"\
"Identifies files with identical content in the directories and all\n"\
"sub directories and prepends __DUPLICATE__ to the files with identical\n"\
"contents.\n"\
"\n"\
"'MXcleaner -i *'\n"\
"Ignores previously saved configuration.\n"\
"Identifies duplicate files with same contents in the current directory \n"\
"and sub directories and prints results to the console\n"\
"\n"\
"MXcleaner (for Linux) -u -d ~/Photos ~/Videos ~/Downloads' or \n"\
"MXcleaner (for Windows) -u -d C:\\Photos C:\\Videos C:\\Downloads' updates the \n"\
"configuration and identifies and optionally permanently DELETES duplicate \n"\
"files in user's Photos, Videos and Downloads directory and it's sub \n"\
"directories and prints results to the console.\n"\
"\n"\
"MXcleaner (for Linux) -c ~/Photos' or 'MXcleaner (for Windows) -d C:\\Photos'\n"\
"identifies files in user's photos directory and it's sub directories and \n"\
"removes __DUPLICATE__ from file names and prints the results to the console.\n"\
"\n"\
"MXcleaner -v' outputs additional technical information\n"\
"\n"\
"Valid command options are:\n"\
"-c, --clean   Removes __DUPLICATE__ from file names.\n"\
"-d, --delete  Permanently deletes duplicate files and incomplete files if \n"\
"              a completed file with identical MX hash value exists.\n"\
"-p, --percent Sets the percentage files must be identical before they are \n"\
"              marked as duplicate files.\n"\
"              Usage -p10 or --percentage10 \n"\
"              Default is 0. \n"\
"-r --remove   Removes remaining __DUPLICATE__ and other prefixes from files\n"\
"              not deleted with the -d or --delete option. \n"\
"-t, --test    make a test run without changes to file names.\n"\
"              Print output to console.\n"\
"-v, --verbose Print verbose output to console.\n"\
"-q, --quiet   Do not print to console.\n"\
"\n"\
"Use only one of these options:\n"\
"-i --ignore = Run and keep existing configuration.\n"\
"-k --kill   = Delete existing configuration.\n"\
"-u --update = Run and update existing configuration.\n"\
"-s --save   = Save configuration, do not run.\n"\
"\n"\
"IMPORTANT! You must restart WinMX after deleleting __INCOMPLETE___ files \n"\
"or they will again be downloaded.\n"\
"\n"\
"To create a logfile use 'MXcleaner [OPTIONS] DIRECTORY > [PATH]logfile.txt'\n"\
"\n"\
"Please e-mail your comments and bug reports to linux@c5ace.com.\n\n";
